unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, OpenGL, Unit2, XPMan, ExtDlgs;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn2: TBitBtn;
    Panel2: TPanel;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Edit5: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit6: TEdit;
    Label9: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Edit9: TEdit;
    Edit8: TEdit;
    Edit7: TEdit;
    BitBtn3: TBitBtn;
    Label13: TLabel;
    ComboBox1: TComboBox;
    Label14: TLabel;
    ComboBox2: TComboBox;
    Label15: TLabel;
    ComboBox3: TComboBox;
    Label16: TLabel;
    Edit10: TEdit;
    Label17: TLabel;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit11: TEdit;
    Label18: TLabel;
    Panel3: TPanel;
    Label19: TLabel;
    Edit12: TEdit;
    Label20: TLabel;
    Edit13: TEdit;
    Label21: TLabel;
    Edit14: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    Edit15: TEdit;
    Label24: TLabel;
    Label25: TLabel;
    Edit16: TEdit;
    Label26: TLabel;
    Edit17: TEdit;
    Label27: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SavePictureDialog1: TSavePictureDialog;
    Edit18: TEdit;
    Label28: TLabel;
    Label29: TLabel;
    Edit19: TEdit;
    Label30: TLabel;
    Label31: TLabel;
    Edit20: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  ghRC:HGLRC;
  ghDC:HDC;
  procedure Draw;
  procedure Draw2;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var  FrBuffer, BufRnd1, BufRndT1, BufRnd2, BufRndT2: array of single;
     LenBuffer:cardinal;
     FG:boolean;

 function bSetupPixelFormat(DC:HDC):boolean;
      var
          pfd:PIXELFORMATDESCRIPTOR;
          ppfd:PPIXELFORMATDESCRIPTOR;
          pixelformat:integer;
      begin
          ppfd := @pfd;
          ppfd.nSize := sizeof(PIXELFORMATDESCRIPTOR);
          ppfd.nVersion := 1;
          ppfd.dwFlags :=  PFD_DRAW_TO_WINDOW xor
                           PFD_SUPPORT_OPENGL xor
                           PFD_DOUBLEBUFFER;
          ppfd.dwLayerMask := PFD_MAIN_PLANE;
          ppfd.iPixelType := PFD_TYPE_RGBA;
          ppfd.cColorBits := 16;           
          ppfd.cDepthBits := 16;
          ppfd.cAccumBits := 0;
          ppfd.cStencilBits := 0;
          pixelformat := ChoosePixelFormat(dc, ppfd);
          if pixelformat=0 then
          begin
              MessageBox(0, '    ', '!', MB_OK);
              bSetupPixelFormat:=FALSE;
              exit;
          end;
          if SetPixelFormat(dc, pixelformat, ppfd)=false then
          begin
              MessageBox(0, '    ', '!', MB_OK);
              bSetupPixelFormat:=FALSE;
              exit;
          end;
          bSetupPixelFormat:=TRUE;
 end;


      procedure piped(a,b,c,d:single;e:boolean);
      begin
        glShadeModel(GL_FLAT);
        if e then glPolygonMode(GL_FRONT_AND_BACK,GL_FILL)
        else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
        glBegin(GL_QUAD_STRIP);
          glVertex3f(a-d/2,-50,b-d/2);
          glVertex3f(a-d/2,-50, b+d/2);
          glVertex3f(a-d/2,-50+100*c,b-d/2);
          glVertex3f(a-d/2,-50+100*c,b+d/2);
          glVertex3f(a+d/2,-50+100*c,b-d/2);
          glVertex3f(a+d/2,-50+100*c,b+d/2);
          glVertex3f(a+d/2,-50,b-d/2);
          glVertex3f(a+d/2,-50,b+d/2);
          glVertex3f(a-d/2,-50,b-d/2);
          glVertex3f(a-d/2,-50,b+d/2);
        glEnd;
        glBegin(GL_QUADS);
          glVertex3f(a-d/2,-50,b+d/2);
          glVertex3f(a-d/2,-50+100*c,b+d/2);
          glVertex3f(a+d/2,-50+100*c,b+d/2);
          glVertex3f(a+d/2,-50,b+d/2);
          glVertex3f(a-d/2,-50,b-d/2);
          glVertex3f(a-d/2,-50+100*c,b-d/2);
          glVertex3f(a+d/2,-50+100*c,b-d/2);
          glVertex3f(a+d/2,-50,b-d/2);
        glEnd;
      end;

 function baza(ax:extended):extended;
 begin
 Result:=frac(StrToFloat(Form1.Edit1.Text)*ax);
 end;

 procedure DrawAx;
 begin
  glLineWidth(4);
  glColor3f(1,0.2,0.2);
  glBegin(GL_LINES);
  glVertex3f(-50,-50,-50);
  glVertex3f(50,-50,-50);
  glEnd;
  glColor3f(0.2,1,0.2);
  glBegin(GL_LINES);
  glVertex3f(-50,-50,-50);
  glVertex3f(-50,50,-50);
  glEnd;
  glColor3f(0.2,0.2,1);
  glBegin(GL_LINES);
  glVertex3f(-50,-50,-50);
  glVertex3f(-50,-50,50);
  glEnd;
  glLineWidth(1);
  glColor3f(0.4,0.2,0.2);
  glBegin(GL_LINES);
  glVertex3f(-50,50,50);
  glVertex3f(50,50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(-50,-50,50);
  glVertex3f(50,-50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(-50,50,-50);
  glVertex3f(50,50,-50);
  glEnd;
  glColor3f(0.2,0.4,0.2);
  glBegin(GL_LINES);
  glVertex3f(50,-50,50);
  glVertex3f(50,50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(-50,-50,50);
  glVertex3f(-50,50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(50,-50,-50);
  glVertex3f(50,50,-50);
  glEnd;
  glColor3f(0.2,0.2,0.4);
  glBegin(GL_LINES);
  glVertex3f(50,50,-50);
  glVertex3f(50,50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(-50,50,-50);
  glVertex3f(-50,50,50);
  glEnd;
  glBegin(GL_LINES);
  glVertex3f(50,-50,-50);
  glVertex3f(50,-50,50);
  glEnd;
 end;

 procedure CalcNormal;
var i:cardinal;
    p1:extended;
    Flt:boolean;
    M, M1, M2, M3:real;
    Ms1,Ms2,Ms3:single;
    Ml1,Ml2,Ml3,PrNor:single;
    D1, D2, D3:real;
    q:integer;
begin
with Form1 do begin
Flt:=Timer1.Enabled;
Timer1.Enabled:=False;
Edit12.Text:='';Edit13.Text:='';
Edit14.Text:='';Edit15.Text:='';
Edit16.Text:='';Edit17.Text:='';
p1:=baza(StrToFloat(Edit2.Text));
M:=trunc(StrToFloat(Edit3.Text))-1;
q:=StrToInt(Edit10.Text);
LenBuffer:=trunc(M*3);
SetLength(FrBuffer,LenBuffer+1);
i:=0; M1:=0; M2:=0; M3:=0;
D1:=0; D2:=0; D3:=0;
Ms1:=0; Ms2:=0; Ms3:=0;
Ml1:=MaxInt; Ml2:=MaxInt; Ml3:=MaxInt;
  while i<LenBuffer do begin
  p1:=baza(p1);
  if ComboBox1.ItemIndex=1 then
  FrBuffer[i]:=q*Sqrt(-2*Ln(p1))
  else FrBuffer[i]:=p1;
  M1:=M1+FrBuffer[i];
  if FrBuffer[i]>Ms1 then Ms1:=FrBuffer[i];
  if FrBuffer[i]<Ml1 then Ml1:=FrBuffer[i];
  inc(i);
  p1:=baza(p1);
  if ComboBox2.ItemIndex=1 then
  FrBuffer[i]:=q*Sqrt(-2*Ln(p1))
  else FrBuffer[i]:=p1;
  M2:=M2+FrBuffer[i];
  if FrBuffer[i]>Ms2 then Ms2:=FrBuffer[i];
  if FrBuffer[i]<Ml2 then Ml2:=FrBuffer[i];
  inc(i);
  p1:=baza(p1);
  if ComboBox3.ItemIndex=1 then
  FrBuffer[i]:=q*Sqrt(-2*Ln(p1))
  else FrBuffer[i]:=p1;
  M3:=M3+FrBuffer[i];
  if FrBuffer[i]>Ms3 then Ms3:=FrBuffer[i];
  if FrBuffer[i]<Ml3 then Ml3:=FrBuffer[i];
  inc(i);
  end;
M1:=M1/M; M2:=M2/M; M3:=M3/M;
i:=0;
  while i<LenBuffer do begin
  D1:=D1+Sqr(FrBuffer[i]);
  FrBuffer[i]:=FrBuffer[i]/(Ms1+Ml1);
  inc(i);
  D2:=D2+Sqr(FrBuffer[i]);
  FrBuffer[i]:=FrBuffer[i]/(Ms2+Ml2);
  inc(i);
  D3:=D3+Sqr(FrBuffer[i]);
  FrBuffer[i]:=FrBuffer[i]/(Ms3+Ml3);
  inc(i);
  end;
D1:=D1/M; D2:=D2/M; D3:=D3/M;
D1:=M/(M-1)*(D1-Sqr(M1)); D2:=M/(M-1)*(D2-Sqr(M2)); D3:=M/(M-1)*(D3-Sqr(M3));
Edit4.Text:=FloatToStr(M1);
Edit5.Text:=FloatToStr(M2);
Edit6.Text:=FloatToStr(M3);
Edit9.Text:=FloatToStr(D1);
Edit8.Text:=FloatToStr(D2);
Edit7.Text:=FloatToStr(D3);
Timer1.Enabled:=Flt;
end;
end;

procedure CalcGist;
var i,j,k:cardinal;
    p1:extended;
    Flt:boolean;
    M,M1,M2:real;
    Ms1,Ms2,MGs1,MGTs1,MGs2,MGTs2:single;
    Ml1,Ml2,MGl1,MGTl1,MGl2,MGTl2:single;
    D1,D2,Stp,U1,U2:real;
    Mm,q,q2:integer;
begin
with Form1 do begin
Flt:=Timer1.Enabled;
Timer1.Enabled:=False;
Edit5.Text:='';Edit8.Text:='';
p1:=baza(StrToFloat(Edit2.Text));
M:=trunc(StrToFloat(Edit3.Text))-1;
q:=StrToInt(Edit10.Text);
LenBuffer:=trunc(M)*2;
SetLength(FrBuffer,LenBuffer+1);
M1:=0; D1:=0;
M2:=0; D2:=0;
U1:=0; U2:=0;
Ms1:=-MaxInt; Ms2:=-MaxInt;
Ml1:=MaxInt; Ml2:=MaxInt;
i:=0;
MGs1:=-MaxInt; MGl1:=MaxInt;
MGs2:=-MaxInt; MGl2:=MaxInt;
MGTs1:=-MaxInt; MGTl1:=MaxInt;
MGTs2:=-MaxInt; MGTl2:=MaxInt;
 while i<LenBuffer do begin
  p1:=baza(p1);
  if ComboBox1.ItemIndex=1 then
  FrBuffer[i]:=q*Sqrt(-2*Ln(p1))
  else FrBuffer[i]:=p1;
  M1:=M1+FrBuffer[i];
  if FrBuffer[i]>Ms1 then Ms1:=FrBuffer[i];
  if FrBuffer[i]<Ml1 then Ml1:=FrBuffer[i];
  inc(i);
  p1:=baza(p1);
  if ComboBox3.ItemIndex=1 then
  FrBuffer[i]:=q*Sqrt(-2*Ln(p1))
  else FrBuffer[i]:=p1;
  M2:=M2+FrBuffer[i];
  if FrBuffer[i]>Ms2 then Ms2:=FrBuffer[i];
  if FrBuffer[i]<Ml2 then Ml2:=FrBuffer[i];
  inc(i);
  end;
M1:=M1/M; M2:=M2/M;
i:=0;
  while i<LenBuffer do begin
  D1:=D1+Sqr(FrBuffer[i]);
  inc(i);
  D2:=D2+Sqr(FrBuffer[i]);
  inc(i);
  end;
D1:=D1/M; D2:=D2/M;
D1:=M/(M-1)*(D1-Sqr(M1));
D2:=M/(M-1)*(D2-Sqr(M2));
Edit4.Text:=FloatToStr(M1);
Edit6.Text:=FloatToStr(M2);
Edit9.Text:=FloatToStr(D1);
Edit7.Text:=FloatToStr(D2);
Mm:=StrToInt(edit11.Text)-1;
SetLength(BufRnd1,Mm+1);
SetLength(BufRndT1,Mm+1);
SetLength(BufRnd2,Mm+1);
SetLength(BufRndT2,Mm+1);
Stp:=(Ms1-Ml1)/Mm;
Edit16.Text:=FloatToStr(Stp);
for i:=0 to Mm do begin
BufRnd1[i]:=0;
BufRndT1[i]:=0;
j:=0;
  while j<LenBuffer do begin
if (FrBuffer[j]>=Stp*i) and (FrBuffer[j]<Stp*(i+1)) then
BufRnd1[i]:=BufRnd1[i]+1;
inc(j); inc(j);
end;
BufRnd1[i]:=BufRnd1[i]/(LenBuffer*0.5);
if BufRnd1[i]>MGs1 then MGs1:=BufRnd1[i];
if BufRnd1[i]<MGl1 then MGl1:=BufRnd1[i];
j:=0;
  while j<LenBuffer do begin
  if ComboBox1.ItemIndex=1 then
BufRndT1[i]:=BufRndT1[i]+(Ml1+(i-1)*Stp+j*Stp*0.5/LenBuffer)/Sqr(q)*exp(-Sqr(Ml1+(i-1)*Stp+j*Stp*0.5/LenBuffer)/Sqr(q)/2)
else BufRndT1[i]:=0.5;
inc(j); inc(j);
end;
if BufRndT1[i]>MGTs1 then MGTs1:=BufRndT1[i];
if BufRndT1[i]<MGTl1 then MGTl1:=BufRndT1[i];
end;
Edit12.Text:=FloatToStr(Ms1);
Edit14.Text:=FloatToStr(Ms2);
for i:=0 to Mm do begin
BufRnd1[i]:=BufRnd1[i]/(MGs1+MGl1);
if ComboBox1.ItemIndex<>1 then
BufRnd1[i]:=BufRnd1[i]/2;
BufRndT1[i]:=BufRndT1[i]/(MGTs1+MGTl1);
U1:=U1+(BufRnd1[i]-BufRndT1[i])*(BufRnd1[i]-BufRndT1[i])
end;
Stp:=(Ms2-Ml2)/Mm;
Edit17.Text:=FloatToStr(Stp);
for i:=0 to Mm do begin
BufRnd2[i]:=0;
BufRndT2[i]:=0;
j:=1;
  while j<LenBuffer do begin
if (FrBuffer[j]>=Stp*i) and (FrBuffer[j]<Stp*(i+1)) then
BufRnd2[i]:=BufRnd2[i]+1;
inc(j); inc(j);
end;
BufRnd2[i]:=BufRnd2[i]/(LenBuffer*0.5);
if BufRnd2[i]>MGs2 then MGs2:=BufRnd2[i];
if BufRnd2[i]<MGl2 then MGl2:=BufRnd2[i];
j:=1;
  while j<LenBuffer do begin
  if ComboBox3.ItemIndex=1 then
BufRndT2[i]:=BufRndT2[i]+(Ml2+(i-1)*Stp+j*Stp*0.5/LenBuffer)/Sqr(q)*exp(-Sqr(Ml2+(i-1)*Stp+j*Stp*0.5/LenBuffer)/Sqr(q)/2)
else BufRndT2[i]:=0.5;
inc(j); inc(j);
end;
if BufRndT2[i]>MGTs2 then MGTs2:=BufRndT2[i];
if BufRndT2[i]<MGTl2 then MGTl2:=BufRndT2[i];
end;
Edit13.Text:=FloatToStr(Ml1);
Edit15.Text:=FloatToStr(Ml2);
for i:=0 to Mm do begin
BufRnd2[i]:=BufRnd2[i]/(MGs2+MGl2);
if ComboBox3.ItemIndex<>1 then
BufRnd2[i]:=BufRnd2[i]/2;
BufRndT2[i]:=BufRndT2[i]/(MGTs2+MGTl2);
U2:=U2+(BufRnd2[i]-BufRndT2[i])*(BufRnd2[i]-BufRndT2[i]);
end;
LenBuffer:=Mm;
U1:=StrToFloat(Edit18.Text)*U1;
U2:=StrToFloat(Edit18.Text)*U2;
Edit19.Text:=FloatToStr(U1);
Edit20.Text:=FloatToStr(U2);
Timer1.Enabled:=Flt;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
      var
         p: TGLArrayf4;
         d: TGLArrayf3;
         q: TGLArrayf3;
      begin
         ghDC := GetDC(Handle);
         if bSetupPixelFormat(ghDC)=false then
           Close();
         ghRC := wglCreateContext(ghDC);
         wglMakeCurrent(ghDC, ghRC);
         glClearColor(0, 0, 0, 0);
         FormResize(Sender);
         glEnable(GL_COLOR_MATERIAL);
         glEnable(GL_DEPTH_TEST);
         glEnable(GL_LIGHTING);
         glEnable(GL_LIGHT0);
           p[0]:=3;
           p[1]:=3;
           p[2]:=3;
           p[3]:=1;
           d[0]:=-1;
           d[1]:=-1;
           d[2]:=-3;
           q[0]:=0.3;
           q[1]:=0.6;
           q[2]:=0.5;
         glLightfv(GL_LIGHT0,GL_POSITION,@p);
         glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,@d);
         glLightfv(GL_LIGHT0,GL_AMBIENT,@q);
      end;

procedure TForm1.FormResize(Sender: TObject);
begin
  glViewport( 10, 10, Width-300, Height-50 );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  glOrtho(-100,100, -100,100, -100,100);
  gluLookAt(0,0,5, 0,0,0, 0,1,0);
  glMatrixMode( GL_MODELVIEW );
  glPushMatrix;
  Draw;
  SwapBuffers(ghDC);
end;

  procedure TForm1.Draw;
  var i:cardinal;
  begin
  glClear(GL_DEPTH_BUFFER_BIT xor GL_COLOR_BUFFER_BIT);
  DrawAx;
  glColor3f(0.8,0.9,0.6);
  glPointSize(1);
  i:=0;
  glBegin(GL_POINTS);
  while i<LenBuffer do begin
  glVertex3f(100*FrBuffer[i]-50,100*FrBuffer[i+1]-50,100*FrBuffer[i+2]-50);
  inc(i);inc(i);inc(i);
  end;
  glEnd;
  end;

  procedure TForm1.Draw2;
  var i,j:cardinal;
  Stp:single;
  begin
  glClear(GL_DEPTH_BUFFER_BIT xor GL_COLOR_BUFFER_BIT);
  glColor3f(0.8,0.9,0.6);
  DrawAx;
  glColor3f(0.7,0.8,0.6);
  Stp:=100/LenBuffer;
  for i:=0 to LenBuffer do
  for j:=0 to LenBuffer do
  piped(Stp*i-50,Stp*j-50,BufRnd1[i]*BufRnd2[j],Stp-2,true);
  glColor3f(0.7,0.4,0.3);
  for i:=0 to LenBuffer do
  for j:=0 to LenBuffer do
  piped(Stp*i-50,Stp*j-50,BufRndT1[i]*BufRndT2[j],Stp-1,false);
  end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      begin
        if ghRC<>0 then
        begin
          wglMakeCurrent(ghDC,0);
          wglDeleteContext(ghRC);
        end;
        if ghDC<>0 then
          ReleaseDC(Handle, ghDC);
      end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if Timer1.Enabled then Timer1.Enabled:=False
else Timer1.Enabled:=True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if FG then Draw2 else Draw;
   glRotatef(2,0,1,0);
   glRotatef(1,1,0,0);
   glRotatef(0.5,0,0,1);
   SwapBuffers(ghDC);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
if RadioButton1.Checked then begin
FG:=false;
CalcNormal;
Draw;
end;
if RadioButton2.Checked then begin
FG:=true;
CalcGist;
Draw2;
end;
   SwapBuffers(ghDC);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
Form1.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
glPopMatrix;
glPushMatrix;
if FG then Draw2
else Draw;
   SwapBuffers(ghDC);
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
RadioButton1.Checked:=true;
RadioButton2.Checked:=false;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
RadioButton2.Checked:=true;
RadioButton1.Checked:=false;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
AboutBox.Show;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var bt:TBitmap;
    Flt:boolean;
begin
Flt:=Timer1.Enabled;
Timer1.Enabled:=false;
bt := TBitmap.Create;
with bt do
begin
  Width := Form1.Width;
  Height := Form1.Height;
  Canvas.CopyRect(ClientRect, Form1.Canvas, Form1.ClientRect);
  if SavePictureDialog1.Execute then
  SaveToFile(SavePictureDialog1.FileName);
  Free;
end;
Timer1.Enabled:=Flt;
end;

end.
